%define anolis_release 2
%{?python_enable_dependency_generator}

%bcond_with tests

Summary:        Pythonic, object-oriented web development framework
Name:           python-cherrypy
Version:        18.8.0
Release:        %{anolis_release}%{?dist}
License:        BSD
URL:            https://cherrypy.dev/
Source0:        https://files.pythonhosted.org/packages/source/C/CherryPy/CherryPy-%{version}.tar.gz
# Ignore cgi-related DeprecationWarnings new in Python 3.11
Patch1:         pytest-ignore-cgi-DeprecationWarnings.patch
# Ignore urllib3.contrib.pyopenssl DeprecationWarnings
Patch2:         pytest-ignore-urllib3-pyopenssl-DeprecationWarnings.patch

BuildArch:      noarch

BuildRequires:  dos2unix python3-devel python3dist(setuptools) python3dist(setuptools-scm)
%if %{with tests}
BuildRequires:  python3dist(cheroot) python3dist(jaraco-collections) python3dist(path) python3dist(portend)
BuildRequires:  python3dist(pytest) python3dist(pytest-cov) python3dist(requests-toolbelt)
BuildRequires:  python3dist(more-itertools) python3dist(coverage) python3dist(pytest) python3-zc-lockfile
%endif

%description
CherryPy allows developers to build web applications in much the same way
they would build any other object-oriented Python program. This usually
results in smaller source code developed in less time.

%package -n python3-cherrypy
Summary:       Pythonic, object-oriented web development framework
%{?python_provide:%python_provide python3-cherrypy}

%description -n python3-cherrypy
CherryPy allows developers to build web applications in much the same way
they would build any other object-oriented Python program. This usually
results in smaller source code developed in less time.

%package -n python3-cherrypy-doc
Summary:        Documentation files for CherryPy
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description -n python3-cherrypy-doc
CherryPy allows developers to build web applications in much the same way
they would build any other object-oriented Python program. This usually
results in smaller source code developed in less time.

This package contains documentation files for CherryPy.

%prep
%autosetup -p1 -n CherryPy-%{version}

dos2unix cherrypy/tutorial/tutorial.conf

# remove fail tests.
rm cherrypy/test/test_session.py
rm cherrypy/test/test_static.py
# See more: https://github.com/cherrypy/cherrypy/pull/1959
sed -i 's/readfp/read_file/' cherrypy/lib/reprconf.py

%build
%py3_build

%install
%py3_install

%if %{with tests}
%check
# Disable WEBTEST_INTERACTIVE as it only causes problems:
# https://github.com/cherrypy/cherrypy/commit/5d3c86eb36dfdf972a1d3c8d69cf8be2050eb99c
export WEBTEST_INTERACTIVE=false
%pytest cherrypy/test \
  --deselect=cherrypy/test/test_tools.py::ToolTests::testCombinedTools \
  -p no:unraisableexception
%endif

%files -n python3-cherrypy
%doc README.rst
%license LICENSE.md
%doc cherrypy/tutorial
%{_bindir}/cherryd
%{python3_sitelib}/*
%exclude %{python3_sitelib}/cherrypy/cherryd
%exclude %{python3_sitelib}/cherrypy/test
%exclude %{python3_sitelib}/cherrypy/tutorial

%changelog
* Wed Mar 27 2024 Bo Ren <rb01097748@alibaba-inc.com> - 18.8.0-2
- Rebuild with python3.11
- Disable tests

* Wed Apr 19 2023 DengXiewei <dengxiewei@linux.alibaba.com> - 18.8.0-1
- Initial from upstream
